require "ShowAttackDistance"

function ShowAttackDistance.changeShowSelection(playerObj)
    if not playerObj then return end
    local md = playerObj:getModData();
    if not md then return end
    if md.ShowAttackDistance == nil then md.ShowAttackDistance = true end
    md.ShowAttackDistance = not md.ShowAttackDistance
end

function ShowAttackDistance.isShowAttackDistance(playerObj)
    if not playerObj then return false end
    local md = playerObj:getModData();
    if not md then return false end
    if md.ShowAttackDistance == nil then md.ShowAttackDistance = true end
    return md.ShowAttackDistance
end

function ShowAttackDistance.createShowButton(context, playerObj)
    local optionText = nil
    local show = ShowAttackDistance.isShowAttackDistance(playerObj)
    if show then
        optionText = getText("IGUI_ShowAttackDistance_Active");
    else
        optionText = getText("IGUI_ShowAttackDistance_Hidden");
    end
    local activeOnContainerOption = context:addOption(optionText, playerObj, ShowAttackDistance.changeShowSelection)

    local tooltip = ISWorldObjectContextMenu.addToolTip();
    tooltip.description = getText("IGUI_ShowAttackDistance_Switch");
    activeOnContainerOption.toolTip = tooltip;

    context:setOptionChecked(activeOnContainerOption, show)
end

--add contextual option to show / hide attack distance
local upperLayerCreateMenu = ISWorldObjectContextMenu.createMenu
ISWorldObjectContextMenu.createMenu = function(playerNum, worldobjects, x, y, test)
    local context = upperLayerCreateMenu(playerNum, worldobjects, x, y, test)
    
    --contextual option for action on other
    local playerObj = getSpecificPlayer(playerNum)
    if not playerObj or not playerObj:isLocalPlayer() then return end

    local deltaX = math.abs(screenToIsoX(playerNum,x,y,playerObj:getZ()) - playerObj:getX())
    local deltaY = math.abs(screenToIsoY(playerNum,x,y,playerObj:getZ()) - playerObj:getY())
    local distance2Dsquare = deltaX*deltaX+deltaY*deltaY
    
    if distance2Dsquare < 0.4 then
        ShowAttackDistance.createShowButton(context, playerObj);
    else
        --print ("distance2Dsquare =", distance2Dsquare,"deltaX =", deltaX,"deltaY =", deltaY)
    end
    
    return context
end